<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="实验室名称:">
                <Input v-model="formObj.name" @on-enter="_formSearch" name="name" placeholder="请输入实验室名称" clearable/>
              </Form-item>
              <Form-item class="search-item" label="资质:">
                <Input v-model="formObj.aptitude" @on-enter="_formSearch" name="aptitude" placeholder="请输入资质" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" hide-checkbox>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.key==='edate'">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <FileManage ref="FileManage"></FileManage>
    <subSampleManage ref="subSampleManage" @on-result-change="_page"></subSampleManage>
    <operationModal ref="operationModal" @on-result-change="_page"></operationModal>
  </div>
</template>
<script>
import { meterEntrust, meterSubcontractor } from '../../../api'
import operationModal from '../../../components/operation/Operation'
import subSampleManage from './MeterSubSampleManage'
export default {
  components: { subSampleManage, operationModal },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubpackageTaskFormId',
      searchOpen: false,
      btn: [
        // {
        //   // meter-review-entrust-pass-btn
        //   type: 'success',
        //   id: '',
        //   name: '通过'
        // },
        // // meter-review-entrust-back-btn
        // {
        //   type: 'success',
        //   id: '',
        //   name: '驳回'
        // }
      ],
      iconMsg: [
        // {
        //   type: 'md-paper',
        //   id: '',
        //   name: '编辑'
        // },
        {
          type: 'ios-beaker',
          id: 'meter-subpackage-task-subpackage-sample-manage-o',
          name: '分包样品管理'
        },
        {
          type: 'md-cloud',
          id: 'meter-subpackage-task-accessory-o',
          name: '附件'
        },
        {
          type: 'md-book',
          id: 'meter-subpackage-task-record-o',
          name: '操作日志'
        }
      ],
      formObj: {
        name: undefined,
        aptitude: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '传真', key: 'fax', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '邮编', key: 'postcode' },
        { title: 'E-mail', key: 'email', width: 120 },
        { title: '委托日期', key: 'edate', width: 120 },
        { title: '费用合计', key: 'fee', width: 120 },
        { title: '合同号', key: 'contractCode', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._editModal(false)
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '分包样品管理':
            this._subSampleManage(data)
            break
          case '编辑':
            this._editModal(true, data.id)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _subSampleManage(data) {
      // 管理样品
      this.$refs.subSampleManage._open(data.id)
    },
    _record(id) {
      this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this.getPage = this.$store.state.FoodSubcontracter.page
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterEntrust.pageSubpackageEntrust(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        // this.$refs.editSubcontractorModal._open(id)
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterEntrust.getVOById(id)
      console.log(result)
      if (result) {
        // this.$refs.editSubcontractorModal._open(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSubcontractor.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
